From 0d25caaeb791ff17b45338201dcd7eb0df0e7270 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 14 2017 09:49:58 +0000
Subject: [PATCH 51/51] allow marking blocks as "explicitly empty"


This doesn't run subsequent tests on blocks like 'filter: ~', e.g. it
won't complain that it's not a dictionary.

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index cd560ac..8e3d6bc 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -450,7 +450,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('dependencies_*')
     def lint_dependencies_exists(self):
-        self.check('dependencies' in self.mmd)
+        self.check(self.mmd.get('dependencies'))
 
     @error
     @guidelines_link('#Module_dependencies')
@@ -464,7 +464,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('dependencies_buildrequires_*')
     def lint_dependencies_buildrequires_exists(self):
-        self.check('buildrequires' in self.mmd['dependencies'])
+        self.check(self.mmd['dependencies'].get('buildrequires'))
 
     @error
     @guidelines_link('#Module_dependencies')
@@ -492,7 +492,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('dependencies_requires_*')
     def lint_dependencies_requires_exists(self):
-        self.check('requires' in self.mmd['dependencies'])
+        self.check(self.mmd['dependencies'].get('requires'))
 
     @error
     @guidelines_link('#Module_dependencies')
@@ -519,7 +519,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('xmd_*')
     def lint_xmd_exists(self):
-        self.check('xmd' in self.mmd)
+        self.check(self.mmd.get('xmd'))
 
     @error
     @guidelines_link('#Extensible_module_metadata_block')
@@ -532,7 +532,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('references_*')
     def lint_references_exists(self):
-        self.check('references' in self.mmd)
+        self.check(self.mmd.get('references'))
 
     @error
     @guidelines_link('#Module_references')
@@ -566,7 +566,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('profiles_*')
     def lint_profiles_exists(self):
-        self.check('profiles' in self.mmd)
+        self.check(self.mmd.get('profiles'))
 
     @error
     @guidelines_link('#Module_profiles')
@@ -613,7 +613,7 @@ class ModuleMDLinter(object):
     @guidelines_link('#Module_API')
     def lint_api_exists(self):
         """Every module SHOULD define its public API."""
-        self.check('api' in self.mmd)
+        self.check(self.mmd.get('api'))
 
     @error
     @guidelines_link('#Module_API')
@@ -660,7 +660,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('filter_*')
     def lint_filter_exists(self):
-        self.check('filter' in self.mmd)
+        self.check(self.mmd.get('filter'))
 
     @error
     @guidelines_link('#Module_filters')
@@ -693,7 +693,7 @@ class ModuleMDLinter(object):
     @prerequisite_for('filter_rpms_*')
     @prerequisite('filter_dict')
     def lint_filter_rpms_exists(self):
-        self.check('rpms' in self.mmd['filter'])
+        self.check(self.mmd['filter'].get('rpms'))
 
     @warning
     @guidelines_link('#Module_filters')
@@ -718,7 +718,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('components_*')
     def lint_components_exists(self):
-        self.check('components' in self.mmd)
+        self.check(self.mmd.get('components'))
 
     @error
     @guidelines_link('#Module_components')
@@ -824,7 +824,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('components_rpms_*')
     def lint_components_rpms_exists(self):
-        self.check('rpms' in self.mmd['components'])
+        self.check(self.mmd['components'].get('rpms'))
 
     @warning
     @guidelines_link('#RPM_content')
@@ -840,7 +840,7 @@ class ModuleMDLinter(object):
     @option
     @prerequisite_for('components_modules_*')
     def lint_components_modules_exists(self):
-        self.check('modules' in self.mmd['components'])
+        self.check(self.mmd['components'].get('modules'))
 
     @warning
     @guidelines_link('#Module_content')

